/* Use OpenGL version 3.3 compatibility to get a wide flexibility */
#version 330 compatibility

/* Instance attributes area */
layout (location = 0) in vec3 position;
layout (location = 1) in vec3 offset;
layout (location = 2) in vec3 color;

/* Uniforms area */
uniform mat4 proj;
uniform mat4 model;
uniform mat4 scale;
uniform int width;
uniform int height;
uniform int depth;

/* Fragment shader outputs area */
out vec4 fragMainColor;

void main(void)
{
    /* Send the instance color to the fragment shader */
    fragMainColor = vec4(color, 1);

    /* Create the camera translation -
    That use the sinus of a 60 degrees FOV */
    vec4 cam = vec4(0, 0, (width + height + depth) / sin(radians(60.0) * 2), 0.0);

    /* Set the vertex position */
    gl_Position = proj * (model * (scale * vec4(position, 1.0) + vec4(offset, 0)) - cam);
}